__author__='sigilis.com'
__version__='0.2.1'
from pandac.PandaModules import HTTPClient,DocumentSpec,URLSpec,Ramfile

class getHTTP():
	def __init__(self,URL,FileOrRam):
		self.http = HTTPClient()
		self.channel = self.http.makeChannel(1) 
		self.channel.beginGetDocument(URLSpec(URL))
		#self.channel=self.http.getDocument(URLSpec(URL))
		self.finished=False
		if FileOrRam=='ram':
			print 'to ram'
			self.rf = Ramfile()
			self.channel.downloadToRam(self.rf)
		taskMgr.add(self.downloadTask, 'download')
		print self.http,self.channel,self.finished

	def downloadTask(self, task):
		print 'download task'
		if self.channel.run():
			print 'running'
			return task.cont
		if not self.channel.isDownloadComplete():
			print 'errorrrrr'
			self.data='ERROR'
			self.finished=True
			return task.done
		self.data = self.rf.getData()
		self.finished=True
		return task.done 
		
	def close(self):
		del(self)		
		
class getSimpleHTTP():
	def __init__(self,URL,FileOrRam):
		self.http = HTTPClient()
		self.channel=self.http.getDocument(URLSpec(URL))
		self.finished=False
		if FileOrRam=='ram':
			self.rf = Ramfile()
			self.channel.downloadToRam(self.rf)
		self.data = self.rf.getData()	
		
	def docCheck(self):
		success=False
		if self.data=='':
			print 'Unable to get versions from server. Maybe next time.'
		elif self.data[:9]=='<!DOCTYPE':
			print 'Unable to get versions from server. Maybe next time.'
		elif self.data[:11]=='QUERY ERROR':
			print 'Server SQL error.'
		elif self.data[:8]=='NO MATCH':
			print 'No SQL Match.'
		elif self.data[:5]=='NO ID':
			print 'Missing ID in Query.'
		else :
			success=True
		return success	
		
	def close(self):
		del(self)
