__author__='sigilis.com'
__version__='0.2.2'


# in order for the main.py program to download a new version
# this getVersions file also need to be updated to the same __version__
# as that set in main.py


from sets import Set,ImmutableSet
import os,fnmatch
from operator import countOf

from libs.getHTTP import getSimpleHTTP
from libs.BasicFunctions import checkForFile,backUpFile,writeFile

from datetime import datetime 

def getVersions(MYDIR):
	localVersions=Set([ImmutableSet(['fold|root','class|main','vers|'+__version__])])
	print 'LOC FULL',localVersions
	subdirs=['libs','modelclasses','updater']
	print 'Checking Local versions...',datetime.now()
	for sub in subdirs:
		for file in os.listdir(MYDIR+'/'+sub):
			if fnmatch.fnmatch(file, '*.py') and file!='__init__.py':
				name = file[:-3]
				exec('import '+sub+'.'+name)
				exec('version= '+sub+'.'+name+'.__version__')
				localVersions.add(ImmutableSet(['fold|'+sub,'class|'+name,'vers|'+version]))

	remoteVersions=[]
	vHTTP=getSimpleHTTP('http://sigilis.com/latestversions.php','ram')
	print 'at the chk moment',datetime.now()
	chk=vHTTP.docCheck()
	print 'after docCheck',datetime.now()

	if chk==True:
		remoteVersions=eval(vHTTP.data)
	vHTTP.close()



	#print 'remoteversions',remoteVersions
	if remoteVersions !=[]:
		remoteSet=Set([])

		for key,val in remoteVersions.iteritems():
			remoteSet.add(val)

		diffRemote=remoteSet-localVersions
		diffLocal=localVersions-remoteSet

		dRem=[]
		dLoc=[]

		for dR in diffRemote:
			dHash={}
			for d in dR:
				dParts=d.split('|')
				dHash[dParts[0]]=dParts[1]
			dRem.append(dHash)


		for dL in diffLocal:
			dHash={}
			for d in dL:
				dParts=d.split('|')
				dHash[dParts[0]]=dParts[1]
			dLoc.append(dHash)

		downloads=[]
		aheads=[]

		for dR in dRem:
			match=False
			dled=False
			for dL in dLoc:
				if dR['class']==dL['class']:
					match=True
					if countOf(dR['vers'],'.')==1:
						if countOf(dL['vers'],'.')==1:
							if float(dL['vers'])<float(dR['vers']):
								downloads.append(dR)
								dled=True



						if countOf(dL['vers'],'.')==2:
							dRV=dR['vers'].split('.')
							dLV=dL['vers'].split('.')

							if dRV[0]>dLV[0]:
								downloads.append(dR)
								dled=True

							elif dRV[0]==dLV[0] and dRV[1]>dLV[1]:
								downloads.append(dR)
								dled=True

					elif countOf(dR['vers'],'.')==2:
						dRV=dR['vers'].split('.')
						dLV=dL['vers'].split('.')

						if countOf(dL['vers'],'.')==1:
							if dRV[0]>dLV[0]:
								downloads.append(dR)
								dled=True
							elif dRV[0]==dLV[0] and dRV[1]>=dLV[1]:
								downloads.append(dR)
								dled=True

						if countOf(dL['vers'],'.')==2:
							if dRV[0]>dLV[0]:
								downloads.append(dR)
								dled=True

							elif dRV[0]==dLV[0] and dRV[1]>dLV[1]:
								downloads.append(dR)
								dled=True

							elif dRV[0]==dLV[0] and dRV[1]==dLV[1] and dRV[2]>dLV[2]:
								downloads.append(dR)
								dled=True

					break



			if match==False:
				downloads.append(dR)



			if dled==False:
				aheads.append(dL)





		if len(aheads)>0:
			print 'You are running versions ahead of the official ones:',aheads



		if len(downloads)>0:
			print 'downloading file(s)...',downloads
			for dl in downloads:
				for rV,val in remoteVersions.iteritems():
					if len(val.intersection(Set(['class|'+dl['class']])))==1:
						vHTTP=getSimpleHTTP('http://sigilis.com/latestclass.php?id='+rV,'ram')
						chk=vHTTP.docCheck()
						if chk==True:
							if dl['fold']=='root':
								filechk=checkForFile(MYDIR+'/'+dl['class']+'.py')
								if filechk==True:
									backfile=backUpFile(MYDIR+'/'+dl['class']+'.py')
									if backfile==True:
										writeFile(MYDIR+'/'+dl['class']+'.py',vHTTP.data)
								else:
									writeFile(MYDIR+'/'+dl['class']+'.py',vHTTP.data)
							else:
								filechk=checkForFile(MYDIR+'/'+dl['fold']+'/'+dl['class']+'.py')
								if filechk==True:
									backfile=backUpFile(MYDIR+'/'+dl['fold']+'/'+dl['class']+'.py')
									if backfile==True:
										writeFile(MYDIR+'/'+dl['fold']+'/'+dl['class']+'.py',vHTTP.data)

								else:
									writeFile(MYDIR+'/'+dl['fold']+'/'+dl['class']+'.py',vHTTP.data)

						vHTTP.close()
						break

