__author__='sigilis.com'
__version__='0.2.2'

from pandac.PandaModules import loadPrcFile,loadPrcFileData,ConfigVariableString
#loadPrcFileData("", "fullscreen 1")
loadPrcFileData("", "window-title Sigilis")
loadPrcFile("config/User.prc")
import direct.directbase.DirectStart
from pandac.PandaModules import Filename
from pandac.PandaModules import WindowProperties


import os,sys

from libs.StartSplash import StartSplash
from libs.User import User
from libs.getVersions import getVersions

global startSplash

def startSplash(user,MYDIR):
	ss=StartSplash(user,MYDIR)	
    				
startInfo={'has':False}
if (sys.argv):
	print 'ARGUMENTS PASSED',sys.argv
	count=0
	for arg in sys.argv:
		garbage=info=''
		if arg.find('sigilis:///') != -1:
			print 'sigilis triple slash in sys arg', count
			garbage,info=arg.split(':///')
		elif arg.find('sigilis://') != -1:
			print 'sigilis double slash in sys arg', count
			garbage,info=arg.split('://')
		elif arg.find('sigilis://') != -1:
			print 'sigilis double slash in sys arg', count
			garbage,info=arg.split('://')
		elif arg.find('sigilis:') != -1:
			print 'sigilis colon marker in sys arg', count
			garbage,info=arg.split(':')
		print 'garbage',garbage,'info',info, 'has',startInfo['has']	
		count+=1	 
	if garbage=='sigilis':
		info=info.split('/')
		print 'INFO', info
		verified=True
		startInfo['type']=info[0]
		if info[0]=='pos':
			if len(info)==4:
				print 'POSITION MARKER RIGHT LENGTH'
				startInfo['sector']=info[1]
				startInfo['x']=info[2]
				startInfo['y']=info[3]
				if len(startInfo['sector'])==0 or len(startInfo['x'])==0 or len(startInfo['y'])==0:
					verified=False
			else:
				verified=False	
		elif info[0]=='grid':
			if len(info)==4:
				startInfo['sector']=info[1]
				startInfo['gridx']=info[2]
				startInfo['gridy']=info[3]
				if len(startInfo['sector'])==0 or len(startInfo['gridx'])==0 or len(startInfo['gridy'])==0:
					verified=False
			else:
				verified=False
		elif info[0]=='star':
			if len(info)==6:
				startInfo['sector']=info[1]
				startInfo[info[2]]=info[3]
				startInfo[info[4]]=info[5]
				if len(startInfo['sector'])==0 or len(startInfo[info[2]])==0 or len(startInfo[info[4]])==0:
					verified=False
			else:
				verified=False
		else:			
			verified=False
		if verified==True:	
			startInfo['has']=True
			print 'VERIFIED MARKER'
			

wp = WindowProperties()
#wp.setTitle('Sigilis')
wp.setSize(int(ConfigVariableString("screenx").getValue()),int(ConfigVariableString("screeny").getValue()))
base.win.requestProperties(wp)	


# Figure out what directory this program is in.
MYDIR=os.path.abspath(sys.path[0])
MYDIRP=Filename.fromOsSpecific(MYDIR).getFullpath()
USERDATA= {	'username':ConfigVariableString("username").getValue(),
		'pwd':ConfigVariableString("pwd").getValue(),
		'modelType':ConfigVariableString("modelType").getValue(),
		'remoteURL':ConfigVariableString("remoteURL").getValue(),
		'sector':int(ConfigVariableString("sector").getValue()),
		'posX':float(ConfigVariableString("posX").getValue()),
		'posY':float(ConfigVariableString("posY").getValue()),
		'posZ':ConfigVariableString("posZ").getValue(),
		'localIP':ConfigVariableString("localIP").getValue(),
		'widescreen':ConfigVariableString("widescreen").getValue()
		
	}	
if USERDATA['posZ']=='':	
	USERDATA['posZ']=None
	
#render.setScale(3)	

if startInfo['has']==True:
	if startInfo['type']=='pos':
		USERDATA['sector']=int(startInfo['sector'])
		USERDATA['posX']=float(startInfo['x'])
		USERDATA['posY']=float(startInfo['y'])
	if startInfo['type']=='grid':
		USERDATA['sector']=int(startInfo['sector'])
		USERDATA['posX']=float( ((int(startInfo['gridx'])-512)*1000)+500 )
		USERDATA['posY']=float( -(((int(startInfo['gridy'])-512)*1000)+500) )
	if startInfo['type']=='star':
		USERDATA['sector']=int(startInfo['sector'])
		if startInfo.has_key('Rs'):
			print 'startinfo has Red Set'
			USERDATA['posX']=-float(startInfo['Rs'])
		elif startInfo.has_key('Rr'):
			print 'startinfo has Red Rise'
			USERDATA['posX']=float(startInfo['Rr'])
		if startInfo.has_key('Gs'):
			print 'startinfo has Green Set'
			USERDATA['posY']=-float(startInfo['Gs'])
		elif startInfo.has_key('Gr'):
			print 'startinfo has Green Rise'
			USERDATA['posY']=float(startInfo['Gr'])
		#USERDATA['posX']=float( ((int(startInfo['gridx'])-512)*1000)+500 )
		#USERDATA['posY']=float( -(((int(startInfo['gridy'])-512)*1000)+500) )

getVersions(MYDIR)
me=User(USERDATA,MYDIR)
startSplash(me,MYDIR)


#print 'maximum texture stages',base.win.getGsg().getMaxTextureStages() 
	
run()	                                                

