__author__='sigilis.com'
__version__='0.2.1'
from Avatar import Avatar
from Edatar import Edatar
from Client import Client             
from OUser import OUser               
from TwoWay import TwoWay          


from datetime import datetime

class User():
	def __init__(self,USERDATA,MYDIR):
		self.username=USERDATA['username']
		self.pwd=USERDATA['pwd']
		self.sector=USERDATA['sector']
		self.modelType=USERDATA['modelType']
		self.remoteURL=USERDATA['remoteURL']
		self.startX=USERDATA['posX']
		self.startY=USERDATA['posY']
		self.startZ=USERDATA['posZ']
		self.MYDIR=MYDIR
		self.others={}
		self.myIP=None
		self.localIP=USERDATA['localIP']
		self.twoway=False
		self.widescreen=USERDATA['widescreen']
		
	def setAvatar(self,terrain=None,
			sx=None,sy=None,sz=None,eyeheight=None):
		self.avatar=Avatar(user=self,terrain=terrain,
				sx=sx,sy=sy,sz=sz,
				eyeheight=eyeheight)
				
	def setEdatar(self,terrain=None,
			sx=None,sy=None,sz=None,myscale=1,eyeheight=None):
		self.edatar=Edatar(user=self,terrain=terrain,
				sx=sx,sy=sy,sz=sz,
				eyeheight=eyeheight)
	def killAvatar(self):			
		self.avatar.delete()
		
	def setClient(self):
		self.client=Client(user=self)
		
	def killClient(self):			
		del self.client		
		
	def killTwoway(self):			
		del self.twoway	
		self.twoway=False
		
	def startTwoWay(self):
		self.twoway=TwoWay(user=self)
		print 'Two Way Server started'
		
	def addOther(self,other):
		if self.twoway==False:
			print 'starting TwoWay';
			self.startTwoWay()
		if not self.others.has_key(other['username']):
			print other['username'],'not registered'
			newother=OUser(other,self.MYDIR)
			print other['username'],'OUser created'
			self.others[other['username']]=newother
			newother.setAvatar(self.avatar.terrain,other['posX'],other['posY'],other['posZ'],4.2)
			print other['username'],'OAvatar created'
			if not self.twoway.OTHERS.has_key(other['username']):
				self.twoway.sendMsgAuth(other['client'],other['localIP'])
